<?php

namespace Drupal\widget_provider_example\EventSubscriber;


use Drupal\widget_provider_example\Widget\WidgetJsExample;
use Drupal\widget_provider_api\Widget\BlankWidgetProvider;
use Drupal\widget_provider_example\Widget\WidgetIFrameExample;
use Drupal\widget_provider_api\Event\RegisterWidgetProvidersEvent;
use Drupal\widget_provider_example\Widget\WidgetDrupalNodeExample;
use Drupal\widget_provider_example\Widget\WidgetDrupalViewExample;
use Drupal\widget_provider_api\EventSubscriber\WidgetProviderEventSubscriber;
use Drupal\widget_provider_example\Widget\WidgetIframeChecksumExample;

/**
 * WidgetProviderAPI event subscriber.
 */
class EventExampleSubscriber extends WidgetProviderEventSubscriber {

  /**
   * Register WidgetExampleProvider to the event.
   *
   * @param RegisterWidgetProvidersEvent $event
   * @return void
   */
  public function registerWidgetProviders(RegisterWidgetProvidersEvent $event) {
    $event->addWidgetProvider(BlankWidgetProvider::create('example-provider1', [new WidgetDrupalNodeExample(), new WidgetDrupalViewExample(), new WidgetIframeExample()]));
    $event->addWidgetProvider(BlankWidgetProvider::create('example-provider2', [new WidgetJsExample(), new WidgetIframeChecksumExample()]));
    \Drupal::messenger()->addMessage('All Widget Providers registrated!');
  }
}
