<?php

namespace Drupal\widget_provider_example\Widget;

use Drupal\views\Views;
use Drupal\widget_provider_api\Widget\WidgetBase;

/**
 * A View Widget Example class.
 * It renders a View as a widget.
 */
class WidgetDrupalViewExample extends WidgetBase {
  /**
   * The WidgetDrupalViewExample Constructor.
   */
  public function __construct() {
    parent::__construct('widget-view-example');
  }

  /**
   * The build function to create the Widget.
   *
   * @return void
   */
  public function build() {
    return $this->buildView('frontpage');
  }

  /**
   * Alternative build() with the Page Body still active.
   *
   * @return array
   */
  public function buildContent(): array {
    return [];
  }

  /**
   * Function for rendering the View
   *
   * @param string $viewName
   * @param string $display
   * @return array
   */
  public function buildView($viewName, $display = 'default'){
    $view = Views::getView($viewName);
    if (is_object($view)) {
      $view->setDisplay($display);
      $view->preExecute();
      $view->execute();
      return $view->buildRenderable();
    }
  }
}
