<?php

namespace Drupal\widget_provider_example\Widget;

use Drupal\widget_provider_api\Widget\WidgetBase;

/**
 * A Iframe Widget Example class.
 * It renders an Iframe as a widget.
 */
class WidgetIFrameExample extends WidgetBase {
  /**
   * The WidgetIFrameExample Constructor.
   */
  public function __construct() {
    parent::__construct('widget-iframe-example');
  }

  /**
   * The build function to create the Widget.
   *
   * @return void
   */
  public function build() {
    return $this->buildIframe('https://www.google.com/');
  }

  /**
   * Alternative build() with the Page Body still active.
   *
   * @return array
   */
  public function buildContent(): array {
    return [];
  }

  /**
   * Function for rendering a iframe
   *
   * @param string $url
   * @return array
   */
  public function buildIframe($url){
    return [
      '#type' => 'inline_template',
      '#template' => '<iframe src="{{ url }}"></iframe>',
      '#context' => [
        'url' => $url,
      ],
    ];
  }
}
