<?php

namespace Drupal\widget_provider_example\Widget;


use Drupal\widget_provider_api\Widget\WidgetBase;
use Symfony\Component\HttpFoundation\JsonResponse;

/**
 * A Javascript Widget Example class.
 * It renders a Script as a widget.
 */
class WidgetJsExample extends WidgetBase{

  /**
   * The WidgetIFrameExample Constructor.
   */
  public function __construct() {
    parent::__construct('widget-js-example', ['kid'], ['hid']);
  }

  /**
   * Alternative build() with the Page Body still active.
   *
   * @return array
   */
  public function buildContent(): array {
    // Nothing here. We use build();
    return [];
  }

  /**
   * Build the Response.
   *
   * @return array|Response
   */
  public function build() {
    $nid = $this->getParameterValue('kid', false);
    $referer = $this->validateAllowedReferer();
    $validate = $this->validateParameters();
    if ($nid === false || $referer === false || $validate === false) {
      // Example for NOT FOUND exception return value:
      return false;
    }
    return JsonResponse::create(['This is an example from JS Example']);
  }
}
