<?php

namespace Drupal\widget_provider_api\Widget;

interface WidgetProviderInterface{
  /**
   * Get WidgetProvider id.
   *
   * @return string
   */
  public function getId(): string;

  /**
   * Get Widget Object.
   *
   * @param string $widgetId
   * @return WidgetInterface
   */
  public function getWidget($widgetId): WidgetInterface;

  /**
   * Returns a Widget Object array.
   *
   * @return WidgetInterface[]
   */
  public function getWidgets(): array;
}
